// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/codescan"
	"github.com/valocode/bubbly/ent/license"
	"github.com/valocode/bubbly/ent/release"
	"github.com/valocode/bubbly/ent/releasecomponent"
	"github.com/valocode/bubbly/ent/releaselicense"
)

// ReleaseLicenseCreate is the builder for creating a ReleaseLicense entity.
type ReleaseLicenseCreate struct {
	config
	mutation *ReleaseLicenseMutation
	hooks    []Hook
}

// SetLicenseID sets the "license" edge to the License entity by ID.
func (rlc *ReleaseLicenseCreate) SetLicenseID(id int) *ReleaseLicenseCreate {
	rlc.mutation.SetLicenseID(id)
	return rlc
}

// SetLicense sets the "license" edge to the License entity.
func (rlc *ReleaseLicenseCreate) SetLicense(l *License) *ReleaseLicenseCreate {
	return rlc.SetLicenseID(l.ID)
}

// SetComponentID sets the "component" edge to the ReleaseComponent entity by ID.
func (rlc *ReleaseLicenseCreate) SetComponentID(id int) *ReleaseLicenseCreate {
	rlc.mutation.SetComponentID(id)
	return rlc
}

// SetNillableComponentID sets the "component" edge to the ReleaseComponent entity by ID if the given value is not nil.
func (rlc *ReleaseLicenseCreate) SetNillableComponentID(id *int) *ReleaseLicenseCreate {
	if id != nil {
		rlc = rlc.SetComponentID(*id)
	}
	return rlc
}

// SetComponent sets the "component" edge to the ReleaseComponent entity.
func (rlc *ReleaseLicenseCreate) SetComponent(r *ReleaseComponent) *ReleaseLicenseCreate {
	return rlc.SetComponentID(r.ID)
}

// SetReleaseID sets the "release" edge to the Release entity by ID.
func (rlc *ReleaseLicenseCreate) SetReleaseID(id int) *ReleaseLicenseCreate {
	rlc.mutation.SetReleaseID(id)
	return rlc
}

// SetRelease sets the "release" edge to the Release entity.
func (rlc *ReleaseLicenseCreate) SetRelease(r *Release) *ReleaseLicenseCreate {
	return rlc.SetReleaseID(r.ID)
}

// AddScanIDs adds the "scans" edge to the CodeScan entity by IDs.
func (rlc *ReleaseLicenseCreate) AddScanIDs(ids ...int) *ReleaseLicenseCreate {
	rlc.mutation.AddScanIDs(ids...)
	return rlc
}

// AddScans adds the "scans" edges to the CodeScan entity.
func (rlc *ReleaseLicenseCreate) AddScans(c ...*CodeScan) *ReleaseLicenseCreate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return rlc.AddScanIDs(ids...)
}

// Mutation returns the ReleaseLicenseMutation object of the builder.
func (rlc *ReleaseLicenseCreate) Mutation() *ReleaseLicenseMutation {
	return rlc.mutation
}

// Save creates the ReleaseLicense in the database.
func (rlc *ReleaseLicenseCreate) Save(ctx context.Context) (*ReleaseLicense, error) {
	var (
		err  error
		node *ReleaseLicense
	)
	if len(rlc.hooks) == 0 {
		if err = rlc.check(); err != nil {
			return nil, err
		}
		node, err = rlc.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ReleaseLicenseMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = rlc.check(); err != nil {
				return nil, err
			}
			rlc.mutation = mutation
			if node, err = rlc.sqlSave(ctx); err != nil {
				return nil, err
			}
			mutation.id = &node.ID
			mutation.done = true
			return node, err
		})
		for i := len(rlc.hooks) - 1; i >= 0; i-- {
			if rlc.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = rlc.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, rlc.mutation); err != nil {
			return nil, err
		}
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (rlc *ReleaseLicenseCreate) SaveX(ctx context.Context) *ReleaseLicense {
	v, err := rlc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (rlc *ReleaseLicenseCreate) Exec(ctx context.Context) error {
	_, err := rlc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (rlc *ReleaseLicenseCreate) ExecX(ctx context.Context) {
	if err := rlc.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (rlc *ReleaseLicenseCreate) check() error {
	if _, ok := rlc.mutation.LicenseID(); !ok {
		return &ValidationError{Name: "license", err: errors.New("ent: missing required edge \"license\"")}
	}
	if _, ok := rlc.mutation.ReleaseID(); !ok {
		return &ValidationError{Name: "release", err: errors.New("ent: missing required edge \"release\"")}
	}
	return nil
}

func (rlc *ReleaseLicenseCreate) sqlSave(ctx context.Context) (*ReleaseLicense, error) {
	_node, _spec := rlc.createSpec()
	if err := sqlgraph.CreateNode(ctx, rlc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{err.Error(), err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	return _node, nil
}

func (rlc *ReleaseLicenseCreate) createSpec() (*ReleaseLicense, *sqlgraph.CreateSpec) {
	var (
		_node = &ReleaseLicense{config: rlc.config}
		_spec = &sqlgraph.CreateSpec{
			Table: releaselicense.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: releaselicense.FieldID,
			},
		}
	)
	if nodes := rlc.mutation.LicenseIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   releaselicense.LicenseTable,
			Columns: []string{releaselicense.LicenseColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: license.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.release_license_license = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := rlc.mutation.ComponentIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   releaselicense.ComponentTable,
			Columns: []string{releaselicense.ComponentColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: releasecomponent.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.release_license_component = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := rlc.mutation.ReleaseIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   releaselicense.ReleaseTable,
			Columns: []string{releaselicense.ReleaseColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: release.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.release_license_release = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := rlc.mutation.ScansIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   releaselicense.ScansTable,
			Columns: releaselicense.ScansPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: codescan.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// ReleaseLicenseCreateBulk is the builder for creating many ReleaseLicense entities in bulk.
type ReleaseLicenseCreateBulk struct {
	config
	builders []*ReleaseLicenseCreate
}

// Save creates the ReleaseLicense entities in the database.
func (rlcb *ReleaseLicenseCreateBulk) Save(ctx context.Context) ([]*ReleaseLicense, error) {
	specs := make([]*sqlgraph.CreateSpec, len(rlcb.builders))
	nodes := make([]*ReleaseLicense, len(rlcb.builders))
	mutators := make([]Mutator, len(rlcb.builders))
	for i := range rlcb.builders {
		func(i int, root context.Context) {
			builder := rlcb.builders[i]
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*ReleaseLicenseMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, rlcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, rlcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{err.Error(), err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				mutation.done = true
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, rlcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (rlcb *ReleaseLicenseCreateBulk) SaveX(ctx context.Context) []*ReleaseLicense {
	v, err := rlcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (rlcb *ReleaseLicenseCreateBulk) Exec(ctx context.Context) error {
	_, err := rlcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (rlcb *ReleaseLicenseCreateBulk) ExecX(ctx context.Context) {
	if err := rlcb.Exec(ctx); err != nil {
		panic(err)
	}
}
