package vulnerabilityreview

import (
	"github.com/valocode/bubbly/cmd/vulnerabilityreview/list"
	"github.com/valocode/bubbly/cmd/vulnerabilityreview/save"
	"github.com/valocode/bubbly/cmd/vulnerabilityreview/set"
	"github.com/valocode/bubbly/config"

	"github.com/spf13/cobra"
)

func New(bCtx *config.BubblyConfig) *cobra.Command {
	cmd := &cobra.Command{
		Aliases: []string{"vr"},
		Use:     "vulnerabilityreview <command>",
		Short:   "Manage bubbly vulnerability reviews",
		Long:    `Manage bubbly vulnerability reviews`,
	}

	cmd.AddCommand(save.New(bCtx))
	cmd.AddCommand(set.New(bCtx))
	cmd.AddCommand(list.New(bCtx))
	return cmd
}
